﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.3
@EndOfDesignText@
Sub Process_Globals
	Private fm As FirebaseMessaging
End Sub

Sub Service_Create
	fm.Initialize("fm")
End Sub

Public Sub SubscribeToTopics
	fm.SubscribeToTopic("general") 'you can subscribe to more topics
End Sub

Sub Service_Start (StartingIntent As Intent)
	Select StartingIntent.Action
		Case "com.google.android.c2dm.intent.REGISTRATION"
			HandleRegistrationResult(StartingIntent)
		Case "com.google.android.c2dm.intent.RECEIVE"
			MessageArrived(StartingIntent)
	End Select

	'If StartingIntent.IsInitialized And fm.HandleIntent(StartingIntent) Then Return
End Sub

Sub MessageArrived (Intent As Intent)
	Dim From, CollapseKey, Data As String 'ignore
	If Intent.HasExtra("from") Then From = Intent.GetExtra("from")
	If Intent.HasExtra("data") Then Data = Intent.GetExtra("data")
	If Intent.HasExtra("collapse_key") Then CollapseKey = Intent.GetExtra("collapse_key")
	Log(Intent.ExtrasToString)
	'Here you should handle the new message:
	Log("New message arrived: " & Data)
	ToastMessageShow("Nuevo mensaje: " & Data, True)
	Dim n As Notification
	n.Initialize
	n.Icon = "icon"
	n.Sound = True
	n.SetInfo(Data, Data, Main)
	n.Notify(1)
End Sub


Sub RegisterDevice (Unregister As Boolean)
	Dim i As Intent
	If Unregister Then
		i.Initialize("com.google.android.c2dm.intent.UNREGISTER", "")
	Else
		i.Initialize("com.google.android.c2dm.intent.REGISTER", "")
		'i.PutExtra("sender", Main.SenderId)
	End If
	Dim r As Reflector
	Dim i2 As Intent
	i2 = r.CreateObject("android.content.Intent")
	Dim pi As Object
	pi = r.RunStaticMethod("android.app.PendingIntent", "getBroadcast", _
		Array As Object(r.GetContext, 0, i2, 0), _
		Array As String("android.content.Context", "java.lang.int", "android.content.Intent", "java.lang.int"))
	i.PutExtra("app", pi)
	Log("FIREBASEMESSAGING"&pi)
	StartService(i)
End Sub

Sub HandleRegistrationResult(Intent As Intent)
	If Intent.HasExtra("error") Then
		Log("Error: " & Intent.GetExtra("error"))
		ToastMessageShow("Error: " & Intent.GetExtra("error"), True)
	Else If Intent.HasExtra("registration_id") Then
		Dim token As String = Intent.GetExtra("registration_id")
		Dim j As HttpJob
		j.Initialize("j", Me)
		
	End If
End Sub

Private Sub JobDone(j As HttpJob)
	If j.Success Then
		Log("Token uploaded successfully.")
	Else
		Log("Error uploading token")
	End If
	j.Release
End Sub

Sub fm_MessageArrived (Message As RemoteMessage)
	Log("fm_MessageArrived:Mensaje Arrived")
	Log($"Message data: ${Message.GetData}"$)
	Dim n As Notification
	n.Initialize
	n.Icon = "icon"
	n.SetInfo(Message.GetData.Get("title"), Message.GetData.Get("body"), Main)
	n.Notify(1)
End Sub

Sub Service_Destroy

End Sub