﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.3
@EndOfDesignText@
'Class MODULE
'modDbClass: v1.00
Sub Class_Globals
	Dim SQL As SQL
	Private sql2 As String
	Type reg_red (dia As Int, hora As Int, minuto As Int, fecha As String)
End Sub

'Initializes the store and sets the store file.
Public Sub Initialize
	Log("modLocDbClass.Initialize:"&Utils.varNombreDB)
	Dim target As String = DBUtils.CopyDBFromAssets(Utils.varNombreDB)
	'Utils.target = DBUtils.fnReplaceDB
	If SQL.IsInitialized Then
		SQL.Close
	End If
	SQL.Initialize(Utils.varDirectory, Utils.varNombreDB, False)
	SQL.ExecNonQuery("VACUUM")
End Sub


public Sub fnIsConnected As Boolean
	If SQL.IsInitialized Then
		Return True
	End If
	Return False
End Sub

Public Sub Finalize
	If SQL.IsInitialized Then
		SQL.Close
	End If
End Sub

Sub del_sic_geo_data
	SQL.ExecNonQuery("DELETE FROM geo_data")
	SQL.Close
End Sub

Sub fnGetCoordenadas
	Dim secuencia As Int
	Dim sql2 As String
	Dim cur_sec, cur_coordenadas As Cursor
	sql2="SELECT max(secuencia) secuencia from geo_data"
	Log("no-ejecuta")
	cur_sec= SQL.ExecQuery(sql2)
	Log("ejecuta")
	If cur_sec.IsInitialized Then
		If cur_sec.RowCount > 0 Then
			cur_sec.Position = 0
			secuencia=cur_sec.GetInt("secuencia")
		End If
		cur_sec.Close
	End If
	If secuencia > 0 Then
		sql2="SELECT latitud,longitud from geo_data where secuencia =" & secuencia
		cur_coordenadas= SQL.ExecQuery(sql2)
		If cur_coordenadas.IsInitialized Then
			If cur_coordenadas.RowCount > 0 Then
				cur_coordenadas.Position = 0
				Utils.Latitud=cur_coordenadas.GetString("latitud")
				Utils.Longitud=cur_coordenadas.GetString("longitud")
				'ToastMessageShow("guardado con sic-geo",False)
			End If
			cur_coordenadas.Close
		Else
			ToastMessageShow("SIGEO no contiene datos, verifique que esté instalado y capturando información!", False)
		End If
	End If
End Sub

Sub fnGetNroFotosbyVcaId(vca_id As String) As Int
	Dim dets As Int = 0
	Dim sql2 As String
	Dim cur_sec As Cursor
	sql2="SELECT count(vca_id) dets from mov_verificaciones_fot_in where vca_id = '"	& vca_id &"'"
	Log("no-ejecuta")
	cur_sec= SQL.ExecQuery(sql2)
	Log("ejecuta")
	If cur_sec.IsInitialized Then
		If cur_sec.RowCount > 0 Then
			cur_sec.Position = 0
			dets=cur_sec.GetInt("dets")
		End If
		cur_sec.Close
	End If
	Return dets
End Sub


Sub fnCargaVarConexion
	Dim rsIP As Cursor
	sql2="SELECT * FROM mov_settings"
	rsIP= SQL.ExecQuery(sql2)
	If rsIP.IsInitialized Then
		If rsIP.RowCount > 0 Then
			rsIP.Position = 0
			Utils.httpServer1=rsIP.GetString("httpServer1")
			Log(fnCargaVarConexion&" URL:"&Utils.httpServer1)
			Utils.httpPort1=rsIP.GetString("httpPort1")
			Utils.httpService1 = "rdc"
			Utils.httpServer2=rsIP.GetString("httpServer2")
			Utils.httpPort2=rsIP.GetString("httpPort2")
			Utils.httpPasswd2=rsIP.GetString("httpPasswd2")
			Utils.httpService2 = "devicetoken"
			Utils.ftpServer=rsIP.GetString("ftpServer")
			Utils.ftpPort=rsIP.GetString("ftpPort")
			Utils.ftpPasswd=rsIP.GetString("ftpPasswd")
			Utils.ftpPath=rsIP.GetString("ftpPath")
			Utils.ftpUser=rsIP.GetString("ftpUser")
			Utils.setReplace=rsIP.GetString("setReplace")
		Else
			Log("No hay datos!")
			Return
		End If
		rsIP.Close
	End If
	Log("JSERVER_IP=" & Utils.httpServer1 &" JPORT="& Utils.httpPort1)
End Sub


Sub prInsToken(token As String)
	SQL.ExecNonQuery("DELETE FROM mov_tokens")
	'DateTime.DateFormat= Utils.dateFormat
	Dim fecha As String=DateTime.Date(DateTime.Now)
	Dim hora As String=DateTime.Time(DateTime.Now)
	Dim m1 As Map
	m1.Initialize
	m1.Clear
	m1.Put("tok_id", 1)
	m1.Put("tok_token", token)
	m1.Put("tok_minDuration", 5)
	m1.Put("tok_fecha", fecha)
	m1.Put("tok_hora", hora)
	Dim listIns As List
	listIns.Initialize
	listIns.add(m1)
	DBUtils.InsertMaps(SQL, "mov_tokens", listIns)
End Sub



Sub prInslog(title As String, error As String)
'	DateTime.DateFormat= Utils.dateFormat
	Dim fecha As String=DateTime.Date(DateTime.Now)
	Dim hora As String=DateTime.Time(DateTime.Now)
	Dim m1 As Map
	m1.Initialize
	m1.Clear
	m1.Put("id", 1)
	m1.Put("title", title)
	m1.Put("Log", error)
	m1.Put("DateTime", fecha&" "&hora)
	Dim listIns As List
	listIns.Initialize
	listIns.add(m1)
	DBUtils.InsertMaps(SQL, "mov_logs", listIns)
End Sub



