﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim reqManager As DBRequestManager
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private db_r As modRemDbClass
	Private db_l As modLocDbClass
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("modPrincipal")
	Activity.Title="Acceso al sistema"	
	DateTime.DateFormat="dd-MM-yyyy"
	'DateUtils.fnValidaFecha("01-01-2017")
	If FirstTime Then
		'-----------------------------------------
		db_r.Initialize
		reqManager=db_r.fnIniConexionRemota(Me, reqManager)
	End If
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	Dim Answ As Int
	If KeyCode = KeyCodes.KEYCODE_BACK  Then
		Answ = Msgbox2("Seguro que desea salir a la pantalla de acceso inicial?", "A T E N C I O N", "SI", "", "No", Null)
		If Answ = DialogResponse.POSITIVE Then
			'StopService(HttpUtils2Service)
			Activity.Finish
			StartActivity("Main")
		End If
		Return True
	Else
		Return False
	End If
End Sub

Sub JobDone (job As HttpJob)
	Log("JobDone.JobName: " & job.JobName & ", JobTag: " & job.Tag& ", JobResult: " & job.Success)
	If job.Success = False Then
		If job.Tag = "serverUp" Then			
			Utils.serverUp = False
			ToastMessageShow("No hay conexion con el Servidor", False)
			Log("ServerUP=FALSE1")
		End If
		If job.Tag ="agente" Then
			
		End If
		'ToastMessageShow(job.tag & " Error en la conexión",False)
		Log("JobDone-"&job.Success)
		'ProgressDialogHide
	Else
		Log("JobDone-"&job.Success)
		'The DBRequest jobname is defined in the class DBRequestManager
		If job.JobName = "DBRequest" Then
			'Get the result which is handled by the ReqManager_Result event
			reqManager.HandleJobAsync(job, "ReqManager")
		End If
	End If
	job.Release
End Sub

Sub ReqManager_Result(result As DBResult)
	Dim filas1, campos As List
	Dim columnas As Map
	Dim  ListaCarga As List
	Log("ReqManager_Result from Tag: " & result.Tag)
	'Depending on the tag, take action f.e. to refresh the table
	Dim i As Int
	Dim l As List
	l.Initialize
	i=0
	filas1.Initialize
	filas1 = result.Rows
	columnas.Initialize
	columnas=result.Columns
	If filas1.Size <= 0 And result.Tag = "serverUp" Then
		ToastMessageShow("No hay conexion DB remota", True)
		Utils.serverUp = False
		Log("serverUP FALSE2")
		
		Return
	Else if filas1.Size > 0 And result.Tag = "serverUp" Then
		Utils.serverUp = True
		Log("serverUP TRUE")
		
		Return
	End If
	If filas1.IsInitialized Then
		If filas1.Size <= 0 Then Return
	End If
	If columnas.IsInitialized Then
		If columnas.Size <= 0 Then Return
	End If
	For Each row() As Object In result.Rows
		For Each record As Object In row
			l.add(record)
			i=i+1
		Next
	Next
	
	'Dim sb As StringBuilder
	campos.Initialize
	campos.Clear
	For Each col In result.Columns.Keys
		campos.Add(col)
	Next
	ListaCarga.Initialize
	ListaCarga.Clear
	For Each row() As Object In result.Rows
		Dim mCargas As Map
		mCargas.Initialize
		mCargas.Clear
		For i=0 To campos.Size-1
			mCargas.Put(campos.Get(i),row(i))
		Next
		ListaCarga.Add(mCargas)
	Next
	 If result.Tag<>"" Then
		If ListaCarga.Size >  0 Then
			'ToastMessageShow("Actualizacion terminada:" & job.Tabla, False)
			DBUtils.DeleteAllRecord(db_l.SQL,result.Tag)
			DBUtils.InsertMaps(db_l.SQL,result.Tag, ListaCarga)
		End If
		ProgressDialogHide
	End If
    
	'	If result.JobName= "upgrade" Then
	'		Dim Out As OutputStream
	'		Out = File.OpenOutput(Utils.varDirectoryApk,Utils.varNombreAPK,False)
	'		File.Copy2(result.GetInputStream,Out)
	'		Out.close
	'		utils.fnUpdateApp
	'		Out.Close
	'		ToastMessageShow("Actualizacion terminada", False)
	'	End If
End Sub