﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.3
@EndOfDesignText@
Sub Process_Globals
	Dim Latitud, Longitud As String
	Dim appVersion As String = "V6.0"
	Dim sf As StringFunctions
	Dim varNombreDB As String = "db_sicapp_ec.db"
	Dim varDirectory As String = File.DirInternal
	'Dim varDirectory As String = File.DirInternal
	Dim varNombreAPK As String = "sicapec.apk"
	Dim varDirectoryApk As String = File.DirRootExternal
	Dim varNombreRed1 As String = "mx_admin"
	Dim varNombreRed2 As String = "marcimex_sistemas"
	'Replace DB
	Dim setReplace As String
	
	'Data base WebServer
	Dim httpServer1, httpService1, httpPasswd1 As String
	'Push notify server
	Dim httpServer2, httpService2, httpPasswd2 As String
	'Updating FTP server
	Dim ftpServer, ftpPath, ftpUser, ftpPasswd As String
	Dim httpPort1,httpPort2,ftpPort As Int
	
	'Para el manejo de usuarios que se conectan desde el aplicativo
	Dim varUsuPasswd, varUsername, varUsuNombre As String
	Dim varAgeIdAgente	As Int
	Dim varDuracionSesion As Int = 7 'Duracion de una sesion del agente, para poder cargar directamente la bandeja de Verificaciones
	'Para el manejo de parametros
	Dim pla_id As Int
	Dim pla_fecha, pla_observaciones As String
	'Dim pScreenWidth, pScreenHeight, pScale, pDPI As Int
	Dim CodigoCliente, NombreCliente, Recorrido, VarTipoDocumento As String
	Dim DireccionEscogida, dir_id_Escogida, NumeroGestiones, NumeroRealizado, CuotaEscogida, ValorCuota, ValorTotal, SumaCuotas As String
	Dim abono_cuota As Int
	Type dataSend ( ctvId As Int,ageId  As Int, ugeId As Int, truId As Int,cliTipoIden As String, cliCedula As String, csvId As Int, csdId As Int, vcoDir As String, vcoTelf As String, vcoDescr As String, garCedula As String, vcoCliGar As String, cliNombre As String, vcoFechaResLab As String, caoId As Int)
	'Data for PushClient
	Public SenderId As String = "497812112159"
	Public DeviceName As String
	Public regid As String	
	Dim varObjVerf As dataSend
	Dim serverUp As Boolean = False
	Dim varUserRespDialogs As Boolean = False
	Dim varEsperaServer As Int = 0
End Sub



'Sub Get_Screen_Resolution  
'pScreenWidth=GetDeviceLayoutValues.Width 
'pScreenHeight=GetDeviceLayoutValues.Height
'pScale=GetDeviceLayoutValues.Scale    
'If pScale= 0.75 Then   
'   pDPI="120" 
'End If    
'If pScale= 1 Then
'   pDPI="160" 
'End If   
'If pScale= 1.5 Then 
'   pDPI="240" 
'End If 
'If pScale=2 Then
'   pDPI="320" 
'End If
''ToastMessageShow(pScreenWidth,True)
'End Sub
Sub fnGetVerificacionId As String
	Dim m, s, d, h As Int
	Dim dt As Long = DateTime.Now
	Dim sec As String
	d = DateTime.GetDayOfYear(dt)
	h = DateTime.GetHour(dt)
	m = DateTime.GetMinute(dt)
	s = DateTime.GetSecond(dt)
	sec = varAgeIdAgente&d&h&m&s
	Log("Utils.fnGetVerificacionId"&sec)
	Return sec
End Sub

Sub decode(texto As String) As String
	Dim strResult As String
	Dim cs As CompressedStreams
	Dim su As StringUtils
	Dim bt() As Byte
	Dim bc As ByteConverter
	Try
		bt = su.DecodeBase64(texto)
		bt = cs.DecompressBytes(bt, "zlib")
		strResult = bc.StringFromBytes(bt, "UTF8")
		Return strResult
	Catch
		Log(LastException)
		Return ""
	End Try
End Sub

Sub encode(texto As String) As String
	Dim strResult As String
	Dim cs As CompressedStreams
	Dim su As StringUtils
	Try
		strResult =  su.EncodeBase64(cs.CompressBytes(texto.GetBytes("UTF8"), "zlib"))
		Return strResult
	Catch
		Log(LastException)
		Return ""
	End Try
End Sub


Sub fnUpdateApp
	Dim iIntent As Intent
	iIntent.Initialize(iIntent.ACTION_VIEW, "file://" & File.Combine(varDirectoryApk,varNombreAPK))
	iIntent.SetType("application/vnd.android.package-archive")
	StartActivity(iIntent)
End Sub

Sub fnValidaWifi(wifi As MLwifi, showAlert As String) As Boolean
	'Validar la conexion DE INTERNET
	If wifi.isWifiConnected Then
		If (wifi.WifiSSID == varNombreRed1) Or (wifi.WifiSSID == varNombreRed2) Then
			Return True
		Else
			If showAlert = "S" Then
				ToastMessageShow("Usted debe conectarse a una red de Marcimex", True)
			End If
			'No tienen una SIDD homogeneo por eso retornamos true
			'Return True
			Return False
		End If
	Else
		If showAlert = "S" Then
			ToastMessageShow("No esta conectado a la red! Encienda o reinicie el Wifi por favor", True)
		End If
		Return False
	End If
End Sub

Sub fnHayConexion (notifica As String) As Boolean
	If serverUp = False Then
		If notifica = "S" Then
			ToastMessageShow("No se pudo establecer conexión!",False)
		End If	
		Return False
	Else
		Return True
	End If
End Sub



Sub fnGetSdkVersion As Double
	Dim p As Phone
	Dim OS As String
	Select p.SdkVersion
		Case 2 : OS = "1.1"
		Case 3 : OS = "1.5"
		Case 4 : OS = "1.6"
		Case 5 : OS = "2.0"
		Case 6 : OS = "2.0" '"2.0.1"
		Case 7 : OS = "2.1"
		Case 8 : OS = "2.2"
		Case 9 : OS = "2.3"
		Case 10 : OS = "2.3" '2.3.x 2.3.3 or 2.3.4
		Case 11 : OS = "3.0"
		Case 12 : OS = "3.1"
		Case 13 : OS = "3.2"
		Case 14 : OS = "4.0"
		Case 15 : OS = "4.0" '4.0.3
		Case 16 : OS = "4.1" '4.1.2
		Case 17 : OS = "4.2" '4.2.2
		Case 18 : OS = "4.3" '4.3.1
		Case 19 : OS = "4.4" '4.4.2
		Case 20 : OS = "4.4" '4.4W.2
		Case 21 : OS = "5.0" '5.0.1
		Case 22 : OS = "5.1" '5.1.1
		Case 23 : OS = "6.0"
		Case 24 : OS = "7.0"
		Case 25 : OS = "7.1" '7.1.71
		Case Else : OS = "?"
	End Select
	'Log("Utils.fnGetSdkVersion:"&OS)
	Return OS
End Sub

Sub FormatoEsp(numero As String, veces As Int) As String
	sf.Initialize
	Dim i As Int
	Dim texto As String
	Dim largo As Int
	texto = numero
	largo = texto.Length
	If largo < veces Then
		For i = 1 To veces - largo
			texto = " " & texto
		Next
	End If
	Return texto
End Sub

Sub fnDoubleToString (val As Double) As String
	Dim resp As String =Round2(val, 4)
	resp = resp.Replace(",",".")
	Return resp
End Sub

Sub FormatoInv(numero As String, veces As Int) As String
	Dim i As Int
	Dim texto As String
	Dim largo As Int
	texto = numero
	largo = texto.Length
	If largo < veces Then
		For i = 1 To veces - largo
			texto = texto & " "
		Next
	End If
	Return texto
End Sub

Sub CheckConnection As Boolean
	Dim P As Phone
	If (P.GetDataState == "CONNECTED") Then
		Return True
	End If
	If (P.GetSettings ("wifi_on") == 1) Then
		Return True
	End If
	If (P.GetDataState == "DISCONNECTED") Then
		Return False
	End If
	If (P.GetDataState == "SUSPENDED") Then
		Return False
	End If
	Return False
End Sub

Sub fnValidaIdentificacion(nro_identificacion As String, tipo As String) As Boolean
	Dim Suma As Double
	Dim Residuo As Double
	Dim Natural, Juridica, Publica, Pasaporte As Boolean
	Dim NumProvincias As Byte
	Dim ValDivision  As Double
	Dim ValMultiplicacion, Valor, valor1 As Double
	Dim VALRESTA As Double
	Dim digitoverificador As Int
	NumProvincias = 24
	Natural = False
	Juridica = False
	Publica = False
	Pasaporte = False
	Dim t As String
	Dim resp As Boolean = False
	Dim nro_ide As String = nro_identificacion.Trim
	Dim c1,c2,c3,c4,c5,c6,c7,c8,c9,c10 As Int
	Dim n1,n2,n3,n4,n5,n6,n7,n8,n9,n10 As String
	Dim p1,p2,p3,p4,p5,p6,p7,p8,p9,p10 As Int
	'ToastMessageShow("CED/RUC:"&nro_ide& " TIPO:"&tipo, False)
	'tipo = "CED" ----->ES VALIDO PARA CEDULA Y RUC
	If tipo = "RUC" Then
		t = "CED"
	Else
		t = tipo
	End If
	If (nro_ide.Trim.Length >= 10 And nro_ide.Trim.Length <= 13 And t = "CED" ) Or (nro_ide.Trim.Length > 5 And t = "PAS") Then
		If (t == "PAS") Then
			Pasaporte = True
		Else
			n1 = sf.Mid(nro_ide,1,1)
			n2 = sf.Mid(nro_ide,2,1)
			n3 = sf.mid(nro_ide,3,1)
			n4 = sf.mid(nro_ide,4,1)
			n5 = sf.mid(nro_ide,5,1)
			n6 = sf.mid(nro_ide,6,1)
			n7 = sf.mid(nro_ide,7,1)
			n8 = sf.mid(nro_ide,8,1)
			n9 = sf.mid(nro_ide,9,1)
			n10 = sf.mid(nro_ide,10,1)
			c1 = n1
			c2 = n2
			c3 = (n3)
			c4 = (n4)
			c5 = (n5)
			c6 = (n6)
			c7 = (n7)
			c8 = (n8)
			c9 = (n9)
			c10 =(n10)
			Select c3
				Case 0,1,2,3,4,5
					Natural = True
				Case  6,7,8  'etenesaca 7,8 para personas naturales
					Natural = True
					Publica = True
				Case  9
					Natural = True
					Juridica = True
			End Select
		End If
		'=======================VALIDAMOS QUE NO TENGA CARACTERES ESPECIALES======================================
		If Natural = True Or Juridica = True Or Publica = True Then
			Dim car_validos As Boolean
			car_validos = Regex.IsMatch("\d+",nro_ide)
			If (nro_ide.Length == 10 Or nro_ide.Length == 13)  And car_validos= True Then
				Natural=Natural
				Juridica = Juridica
				Publica = Publica
			Else
				ToastMessageShow("La cedula o ruc debe contener solo números y debe tener 10 o 13 caracteres"&nro_identificacion&" Tipo "&tipo, False)
				' ToastMessageShow("La cedula o ruc debe contener solo números y debe tener 10 o 13 caracteres", False)
				Return False
			End If
		End If
		'=================================NATURAL==============================================
		If Natural = True Then
			Valor=sf.Mid(nro_ide,1,2)
			If Valor > 0 And (Valor <= NumProvincias Or  Valor = 30) Then 'valor = 30 => Número reservado para ecuatorianos registrados en el exterior.
				p1 = c1 * 2
				p2 = c2
				p3 = c3 * 2
				p4 = c4
				p5 = c5 * 2
				p6 = c6
				p7 = c7 * 2
				p8 = c8
				p9 = c9 * 2
				p10 = c10
				If p1 > 9  Then p1 = p1 - 9
				If p3 > 9 Then p3 = p3 - 9
				If p5 > 9 Then p5 = p5 - 9
				If p7 > 9 Then p7 = p7 - 9
				If p9 > 9 Then p9 = p9 - 9
				Suma = p1 + p2 + p3 + p4 + p5 + p6 + p7 + p8 + p9 + p10
				Log("Suma"&Suma)
				Residuo = Suma Mod 10
				Log("Residuo"&Residuo)
				If nro_ide.Trim.Length = 10 Then
					If Residuo = 0 Then
						resp = True
					Else
						'ToastMessageShow("La Cédula no es valida", False)
						ToastMessageShow("La Cédula no es valida "&nro_identificacion&" Tipo "&tipo, False)
						resp =False
					End If
				Else If nro_ide.Trim.Length = 13 Then
					If Residuo = 0 Then
						Valor=sf.Mid(nro_ide,11,3)
						If Valor = 1 And sf.Mid(nro_ide,11,3).Length = 3 Then
							resp =True
						Else
							ToastMessageShow("RUC correspondiente a Persona Natural es incorrecta", False)
							resp = False
						End If
					End If
				End If
			Else
				ToastMessageShow("RUC correspondiente a Persona Natural es incorrecta", False)
				resp = False
			End If
		End If ' natural
		'================================JURÍDICA===========================================
		If Juridica = True And resp = False Then
			Valor=sf.Mid(nro_ide,1,2)
			If Valor > 0 And (Valor <= NumProvincias Or  Valor = 30) Then 'valor = 30 => Número reservado para ecuatorianos registrados en el exterior.
				If nro_ide.Trim.Length = 13 Then
					p1 = c1 * 4
					p2 = c2 * 3
					p3 = c3 * 2
					p4 = c4 * 7
					p5 = c5 * 6
					p6 = c6 * 5
					p7 = c7 * 4
					p8 = c8 * 3
					p9 = c9 * 2
					Suma = p1 + p2 + p3 + p4 + p5 + p6 + p7 + p8 + p9
					ValDivision = (Suma / 11)
					ValDivision=Floor(ValDivision)
					ValMultiplicacion = ValDivision * 11
					VALRESTA = Suma - ValMultiplicacion ' RESIDUO
					If VALRESTA = 0 Then
						digitoverificador = 0
					Else
						digitoverificador = 11 - VALRESTA
					End If
					Valor=sf.Mid(nro_ide,11,3)
					If digitoverificador = c10 And Valor = 1 Then
						resp = True
					Else
						ToastMessageShow("RUC correspondiente a Persona Jurídica es incorrecta", False)
						resp = False
					End If
				End If
			Else
				ToastMessageShow("RUC correspondiente a Persona Jurídica es incorrecta",False)
				resp = False
			End If
		End If
		'==================================PÚBLICA==========================================
		If Publica = True And resp = False  Then
			Valor=sf.Mid(nro_ide,1,2)
			If Valor > 0 And(Valor <= NumProvincias Or  Valor = 30) Then 'valor = 30 => Número reservado para ecuatorianos registrados en el exterior.
				If nro_ide.Trim.Length = 13 Then
					p1 = c1 * 3
					p2 = c2 * 2
					p3 = c3 * 7
					p4 = c4 * 6
					p5 = c5 * 5
					p6 = c6 * 4
					p7 = c7 * 3
					p8 = c8 * 2
					Suma = p1 + p2 + p3 + p4 + p5 + p6 + p7 + p8
					ValDivision = Floor(Suma / 11)
					ValMultiplicacion = ValDivision * 11
					VALRESTA = Suma - ValMultiplicacion
					digitoverificador = 11 - VALRESTA
					valor1=sf.Mid(nro_ide,11,3)
					Valor=sf.Mid(nro_ide,10,4)
					If c9 = digitoverificador And Valor > 0 And valor1 = 1 Or VALRESTA = 0 Then
						resp = True
					Else
						ToastMessageShow("RUC correspondiente a Empresas del Sector Público es incorrecta", False)
						resp = False
					End If
				End If
			Else
				ToastMessageShow("RUC correspondiente a Empresas del Sector Público es incorrecta", False)
				resp = False
			End If
		End If
		'==================================PASAPORTE==========================================
		If Pasaporte = True And resp = False Then
			Dim car_validos As Boolean
			car_validos =Regex.IsMatch("\d+\w+",nro_ide)
			If (nro_ide.Length < 20 Or nro_ide.Length >= 5) And car_validos=True Then
				resp = True
			Else
				ToastMessageShow("El pasaporte no debe contener caracteres especiales,excepto - "&nro_identificacion&" Tipo "&tipo, False)
				'ToastMessageShow("El pasaporte no debe contener caracteres especiales,excepto - ", False)
				resp = False
			End If
		End If
	Else
		ToastMessageShow("Numero de Documento no válido "&nro_identificacion&" Tipo "&tipo, False)
		resp = False
	End If
	Return resp
End Sub


